# coding: utf-8

"""
    Telegram Bot API

    Auto-generated OpenAPI schema

    The version of the OpenAPI document: 8.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from tele_api_python.models.chat import Chat
from tele_api_python.models.user import User
from typing import Optional, Set
from typing_extensions import Self

class PollAnswer(BaseModel):
    """
    This object represents an answer of a user in a non-anonymous poll.
    """ # noqa: E501
    poll_id: StrictStr = Field(description="Unique poll identifier")
    voter_chat: Optional[Chat] = None
    user: Optional[User] = None
    option_ids: List[StrictInt] = Field(description="0-based identifiers of chosen answer options. May be empty if the vote was retracted.")
    __properties: ClassVar[List[str]] = ["poll_id", "voter_chat", "user", "option_ids"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PollAnswer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of voter_chat
        if self.voter_chat:
            _dict['voter_chat'] = self.voter_chat.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PollAnswer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "poll_id": obj.get("poll_id"),
            "voter_chat": Chat.from_dict(obj["voter_chat"]) if obj.get("voter_chat") is not None else None,
            "user": User.from_dict(obj["user"]) if obj.get("user") is not None else None,
            "option_ids": obj.get("option_ids")
        })
        return _obj


