# coding: utf-8

"""
    Telegram Bot API

    Auto-generated OpenAPI schema

    The version of the OpenAPI document: 8.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from tele_api_python.models.inline_query_result import InlineQueryResult
from typing import Optional, Set
from typing_extensions import Self

class SavePreparedInlineMessagePostRequest(BaseModel):
    """
    SavePreparedInlineMessagePostRequest
    """ # noqa: E501
    user_id: StrictInt = Field(description="Unique identifier of the target user that can use the prepared message")
    result: InlineQueryResult
    allow_user_chats: Optional[StrictBool] = Field(default=None, description="Pass *True* if the message can be sent to private chats with users")
    allow_bot_chats: Optional[StrictBool] = Field(default=None, description="Pass *True* if the message can be sent to private chats with bots")
    allow_group_chats: Optional[StrictBool] = Field(default=None, description="Pass *True* if the message can be sent to group and supergroup chats")
    allow_channel_chats: Optional[StrictBool] = Field(default=None, description="Pass *True* if the message can be sent to channel chats")
    __properties: ClassVar[List[str]] = ["user_id", "result", "allow_user_chats", "allow_bot_chats", "allow_group_chats", "allow_channel_chats"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SavePreparedInlineMessagePostRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of result
        if self.result:
            _dict['result'] = self.result.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SavePreparedInlineMessagePostRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "user_id": obj.get("user_id"),
            "result": InlineQueryResult.from_dict(obj["result"]) if obj.get("result") is not None else None,
            "allow_user_chats": obj.get("allow_user_chats"),
            "allow_bot_chats": obj.get("allow_bot_chats"),
            "allow_group_chats": obj.get("allow_group_chats"),
            "allow_channel_chats": obj.get("allow_channel_chats")
        })
        return _obj


